<?php
/*------------------------------------------------------------------------
# "Hot Lightbox" Joomla module
# Copyright (C) 2010 HotThemes. All Rights Reserved.
# License: http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
# Author: HotJoomlaTemplates.com
# Website: http://www.hotjoomlatemplates.com
-------------------------------------------------------------------------*/

// no direct access
defined('_JEXEC') or die('Restricted access');

// get the document object
$doc = JFactory::getDocument();

// load jQuery
JHtml::_('jquery.framework');

// load scripts
$doc->addScript($mosConfig_live_site.'/modules/mod_hot_lightbox/js/jquery.lightbox-0.5.min.js');

// add your stylesheet
$doc->addStyleSheet( 'modules/mod_hot_lightbox/tmpl/style.css' );

// style declaration
$doc->addStyleDeclaration( '

.clear {
	clear:both;
}

#gallery {
	width:'.$moduleWidth.'px;
	height:'.$moduleHeight.'px;
	overflow: '.$overflow.';
}

#gallery img {
	margin:0px '.$thumbsMarginH.'px '.$thumbsMarginV.'px 0px;
	padding:'.$thumbsPadding.'px;
	border:'.$borderWidth.'px solid '.$borderColor.';
}

#gallery img:hover {
	border-color:'.$borderHoverColor.';
}
' );

?>
<script type="text/javascript">
	jQuery(function() {
		jQuery('#gallery a').lightBox({
			imageLoading:'<?php echo $mosConfig_live_site; ?>/modules/mod_hot_lightbox/images/lightbox-ico-loading.gif',
			imageBtnPrev:'<?php echo $mosConfig_live_site; ?>/modules/mod_hot_lightbox/images/lightbox-btn-prev.gif',
			imageBtnNext:'<?php echo $mosConfig_live_site; ?>/modules/mod_hot_lightbox/images/lightbox-btn-next.gif',
			imageBtnClose:'<?php echo $mosConfig_live_site; ?>/modules/mod_hot_lightbox/images/lightbox-btn-close.gif',
			imageBlank:'<?php echo $mosConfig_live_site; ?>/modules/mod_hot_lightbox/images/lightbox-blank.gif'
		});
		jQuery('#gallery img').last().css('margin-right','0px');
	});
</script>

<div id="gallery">
	<?php
	$images_dir = $images_dir."/";
	$thumbs_dir = $images_dir."thumbs/";

	// START gallery code
	if (!function_exists('make_thumb_v')) {	
		function make_thumb_v($src,$dest,$desired_height) {
			/* read the source image */
			$source_image = imagecreatefromjpeg($src);
			$width = imagesx($source_image);
			$height = imagesy($source_image);
			/* find the "desired width" of this thumbnail, relative to the desired height  */
			$desired_width = floor($width*($desired_height/$height));
			/* create a new, "virtual" image */
			$virtual_image = imagecreatetruecolor($desired_width,$desired_height);
			/* copy source image at a resized size */
			imagecopyresized($virtual_image,$source_image,0,0,0,0,$desired_width,$desired_height,$width,$height);
			/* create the physical thumbnail image to its destination */
			imagejpeg($virtual_image,$dest);
		}
	}

	if (!function_exists('make_thumb')) {			
		function make_thumb($Dir,$Image,$NewDir,$NewImage,$MaxWidth,$MaxHeight,$Quality) {
		  list($ImageWidth,$ImageHeight,$TypeCode)=getimagesize($Dir.$Image);
		  $ImageType=($TypeCode==1?"gif":($TypeCode==2?"jpeg":
					 ($TypeCode==3?"png":FALSE)));
		  $CreateFunction="imagecreatefrom".$ImageType;
		  $OutputFunction="image".$ImageType;
		  if ($ImageType) {
			$Ratio=($ImageHeight/$ImageWidth);
			$ImageSource=$CreateFunction($Dir.$Image);
			if ($ImageWidth > $MaxWidth || $ImageHeight > $MaxHeight) {
			  if ($ImageWidth > $MaxWidth) {
				 $ResizedWidth=$MaxWidth;
				 $ResizedHeight=$ResizedWidth*$Ratio;
			  }
			  else {
				$ResizedWidth=$ImageWidth;
				$ResizedHeight=$ImageHeight;
			  }       
			  if ($ResizedHeight > $MaxHeight) {
				$ResizedHeight=$MaxHeight;
				$ResizedWidth=$ResizedHeight/$Ratio;
			  }      
			  $ResizedImage=imagecreatetruecolor($ResizedWidth,$ResizedHeight);
			  imagecopyresampled($ResizedImage,$ImageSource,0,0,0,0,$ResizedWidth,
								 $ResizedHeight,$ImageWidth,$ImageHeight);
			}
			else {
			  $ResizedWidth=$ImageWidth;
			  $ResizedHeight=$ImageHeight;     
			  $ResizedImage=$ImageSource;
			}   
			$OutputFunction($ResizedImage,$NewDir.$NewImage,$Quality);
			return true;
		  }   
		  else
			return false;
		}
	}

	/* function:  returns files from dir */
	if (!function_exists('get_files')) {	
		function get_files($images_dir,$exts = array('jpg')) {
			$files = array();
			if($handle = opendir($images_dir)) {
				while(false !== ($file = readdir($handle))) {
					$extension = strtolower(get_file_extension($file));
					if($extension && in_array($extension,$exts)) {
						$files[] = $file;
					}
				}
				closedir($handle);
			}
			return $files;
		}
	}

	/* function:  returns a file's extension */
	if (!function_exists('get_file_extension')) {	
		function get_file_extension($file_name) {
			return substr(strrchr($file_name,'.'),1);
		}
	}

	/** settings **/

	//$images_dir = 'preload-images/';
	if (!is_dir($images_dir."thumbs")) {
		mkdir($images_dir."thumbs", 0755);
	}

	$image_files = get_files($images_dir);
	sort($image_files);
	if (count($image_files)) {
		$index = 0;
		foreach($image_files as $index=>$file) {
			$index++;
			$thumbnail_image = $thumbs_dir."thumb_".$file;
			if(!file_exists($thumbnail_image)) {
				$extension = get_file_extension($thumbnail_image);
				if($extension) {
					make_thumb($images_dir,$file,$thumbs_dir,"thumb_".$file,$thumbs_width,$thumbs_height,$image_quality);
				}
			}
			echo '<a href="'.$images_dir.$file.'"><img src="'.$thumbnail_image.'" alt="lightbox" /></a>';
			// if($index % $images_per_row == 0) { echo '<div class="clear"></div>'; }
		}
	}
	else {
		echo '<p>There are no images in this gallery.</p>';
	}				
	// END gallery code
	?>
</div>